import peasy.*;
PeasyCam cam;

float D=25.0;
int N=6;
float H=0.8;

ArrayList<Rect> rects; 

class Rect{
  float p0x,p0y,p0z;
  float p1x,p1y,p1z;
  float p2x,p2y,p2z;
  float p3x,p3y,p3z;
  Rect(float pp0x,float pp0y,float pp0z,float pp1x,float pp1y,float pp1z,float pp2x,float pp2y,float pp2z,float pp3x,float pp3y,float pp3z){
   p0x=pp0x;p0y=pp0y;p0z=pp0z;
   p1x=pp1x;p1y=pp1y;p1z=pp1z;
   p2x=pp2x;p2y=pp2y;p2z=pp2z;
   p3x=pp3x;p3y=pp3y;p3z=pp3z;
  }
}
  
void setup(){
 size(800, 800, P3D);
 cam = new PeasyCam(this, 0,0,0,200);
 cam.setMinimumDistance(-100);
 cam.setMaximumDistance(500);
 rects = new ArrayList<Rect>();
 rects.add(new Rect(-50,-50,0, 50,-50,0, 50,50,0, -50,50,0));
 subdivision();
}

void draw(){
  // dessin de la scene
  background(250);
  //noStroke();
  lights();
  //fill(255);
  color cto = color(254, 102, 0);
  color cfrom = color(0, 102, 253);

  for (Rect p : rects ) {
   fill(lerpColor(cfrom,cto,map(p.p0z,-30,+30,0,1)));
   beginShape();
   vertex(p.p0x,p.p0y,p.p0z);
   vertex(p.p1x,p.p1y,p.p1z);
   vertex(p.p2x,p.p2y,p.p2z);
   endShape(CLOSE);
   beginShape();
   vertex(p.p2x,p.p2y,p.p2z);
   vertex(p.p3x,p.p3y,p.p3z);
   vertex(p.p0x,p.p0y,p.p0z);
   endShape(CLOSE);
  }
}

void subdivision(){
 float s = D;
 for(int i=1;i<=N;i++){
  int taille=rects.size();
  for (int j=0;j<taille;j++ ) {
   Rect p = rects.get(j);
   // calculer le centroide
   float xc = (p.p0x+p.p1x+p.p2x+p.p3x)/4;
   float yc = (p.p0y+p.p1y+p.p2y+p.p3y)/4;
   float zc = (p.p0z+p.p1z+p.p2z+p.p3z)/4;
   // tilter le z du centroide
   zc = Normal(zc, s);
   // creer quatre rect en plus
   rects.add(new Rect(p.p0x,p.p0y,p.p0z, 
                      (p.p0x+p.p1x)/2,(p.p0y+p.p1y)/2,(p.p0z+p.p1z)/2, 
                      xc,yc,zc,
                      (p.p0x+p.p3x)/2,(p.p0y+p.p3y)/2,(p.p0z+p.p3z)/2));
   rects.add(new Rect((p.p0x+p.p1x)/2,(p.p0y+p.p1y)/2,(p.p0z+p.p1z)/2,
                      p.p1x,p.p1y,p.p1z, 
                      (p.p1x+p.p2x)/2,(p.p1y+p.p2y)/2,(p.p1z+p.p2z)/2,
                      xc,yc,zc));
   rects.add(new Rect(xc,yc,zc, 
                     (p.p1x+p.p2x)/2,(p.p1y+p.p2y)/2,(p.p1z+p.p2z)/2,
                      p.p2x,p.p2y,p.p2z,
                     (p.p2x+p.p3x)/2,(p.p2y+p.p3y)/2,(p.p2z+p.p3z)/2));
   rects.add(new Rect((p.p3x+p.p0x)/2, (p.p3y+p.p0y)/2, (p.p3z+p.p0z)/2,
                     xc,yc,zc,
                     (p.p2x+p.p3x)/2, (p.p2y+p.p3y)/2, (p.p2z+p.p3z)/2,
                     p.p3x,p.p3y,p.p3z));
  }
   // detruit la vielle liste de rect, doit etre fait de la queue vers la tete
  for (int j=taille-1;j>=0;j-- ) {
   rects.remove(j);
  }
  // prochaine etape de subdivision
  s /= pow(2.0,H);
}
}

float Normal(float m, float s) {
  //return random(m-1.732*s,m+1.732*s);
  /*float theta = random(0,2*PI);
  float r = sqrt(-2*log(random(0,1)));
  return m+s*r*cos(theta);
  */
  return m + s*randomGaussian();
}

void keyPressed(){
  rects = new ArrayList<Rect>();
  rects.add(new Rect(-50,-50,0, 50,-50,0, 50,50,0, -50,50,0));
  subdivision();
  /*
  for (Rect p : rects ) {
   print(" (0) ",p.p0x,p.p0y,p.p0z);
   print(" (1) ",p.p1x,p.p1y,p.p1z);
   print(" (2) ",p.p2x,p.p2y,p.p2z);
   println(" (3) ",p.p3x,p.p3y,p.p3z);
  }
  println("---");
  */
}